user www-data;
worker_processes auto;
pid /run/nginx.pid;
include /etc/nginx/modules-enabled/*.conf;

events {
        worker_connections 1024;
        # multi_accept on;
}

http {
    ##
    # Basic Settings
    ##

    sendfile on;
    tcp_nopush on;
    types_hash_max_size 2048;
    server_tokens off;

    # server_names_hash_bucket_size 64;
    # server_name_in_redirect off;

    include /etc/nginx/mime.types;
    default_type application/octet-stream;

    ##
    # SSL Settings
    ##

    ssl_protocols TLSv1 TLSv1.1 TLSv1.2 TLSv1.3; # Dropping SSLv3, ref: POODLE
    ssl_prefer_server_ciphers on;
    ssl_dhparam /etc/nginx/cert/dhparams.pem;

    ##
    # Logging Settings
    ##
    log_format main '$remote_addr - $remote_user [$time_local] "$request" '
                        '$status $body_bytes_sent "$http_referer" '
                        '"$http_user_agent" "$http_x_forwarded_for"';
    access_log /var/log/nginx/access.log  main;
    error_log /var/log/nginx/error.log;

    ##
    # Gzip Settings
    ##

    gzip on;

    gzip_vary on;
    gzip_proxied any;
    gzip_comp_level 6;
    gzip_buffers 16 8k;
    gzip_http_version 1.1;
    gzip_types text/plain text/css application/json application/javascript text/xml application/xml application/xml+rss text/javascript;

    ##
    # Virtual Host Configs
    ##
    keepalive_timeout  65;
    client_max_body_size 1024m;

    server {
        listen       80;
        listen  [::]:80;
        server_name  localhost;
        
        # 修改允许最大请求体大小为100MB
        client_max_body_size 100M;
        # 持久连接的超时时间默认60s
        keepalive_timeout    180s;

        #access_log  /var/log/nginx/host.access.log  main;

        # ssl_certificate /etc/nginx/cert/www.x.cn_chain.crt;
        # ssl_certificate_key /etc/nginx/cert/www.x.cn.key;

        # ssl_protocols TLSv1.1 TLSv1.2 TLSv1.3;
        # ssl_session_timeout  5m;
        # ssl_ciphers EECDH+CHACHA20:EECDH+AES128:RSA+AES128:EECDH+AES256:RSA+AES256:EECDH+3DES:RSA+3DES:!MD5;
        # ssl_prefer_server_ciphers on;
        # ssl_dhparam /etc/nginx/cert/dhparams.pem;

        # OMC
        location / {
            root /usr/local/bin/web;
            #root /usr/local/etc/omc/frontend;

            try_files $uri $uri/ /index.html;
            index  index.html index.htm;
        }

        location /omc-api/ {
            proxy_pass http://127.0.0.1:33030/;
            
            proxy_connect_timeout  180s;       # 默认60s
            proxy_send_timeout     180s;       # 默认60s
            proxy_read_timeout     180s;       # 默认60s
            
            proxy_cache_bypass                  $http_upgrade;
            proxy_set_header Upgrade            $http_upgrade;
            proxy_set_header Connection         "upgrade";
            proxy_set_header Host               $host;
            proxy_set_header X-Real-IP          $remote_addr;
            proxy_set_header X-Forwarded-For    $proxy_add_x_forwarded_for;
            proxy_set_header X-Forwarded-Proto  $scheme;
            proxy_set_header X-Forwarded-Host   $host;
            proxy_set_header X-Forwarded-Port   $server_port;
        }

        location /api/rest/ {
            # 添加斜杠并重定向
            #rewrite ^([^.]*[^/])$ $1/ permanent;
            proxy_pass http://127.0.0.1:33030/api/rest/;

            proxy_cache_bypass  $http_upgrade;
            proxy_set_header Upgrade            $http_upgrade;
            proxy_set_header Connection         "upgrade";
            proxy_set_header Host               $host;
            proxy_set_header X-Real-IP          $remote_addr;
            proxy_set_header X-Forwarded-For    $proxy_add_x_forwarded_for;
            proxy_set_header X-Forwarded-Proto  $scheme;
            proxy_set_header X-Forwarded-Host   $host;
            proxy_set_header X-Forwarded-Port   $server_port;
        }

        #error_page  404              /404.html;

        # redirect server error pages to the static page /50x.html
        #
        error_page   500 502 503 504  /50x.html;
        location = /50x.html {
            root   /usr/local/etc/omc/frontend;
        }
    }
}
